<template>
  <v-menu
    v-model="isToShowDatePicker"
    offset-y
    min-width="auto"
    transition="scale-transition"
    :close-on-content-click="false"
  >
    <template v-slot:activator="{ on, attrs }">
      <v-text-field
        :value="formattedValueToDisplay"
        v-bind="{ ...attrs, ...$attrs }"
        readonly
        prepend-icon="mdi-calendar"
        :rules="rules"
        :placeholder="$t('placeholder')"
        v-on="{ ...on, ...$listeners }"
      />
    </template>
    <raw-date-picker-single-field
      :value="value"
      :min="min"
      :max="max"
      :type="datePickerType"
      @input="onSelectDate"
    />
  </v-menu>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import { required } from '@/lib/validators'

  export default {
    name: 'DatePickerSingleField',
    mixins: [DatesMixin],
    inheritAttrs: false,
    props: {
      value: {
        type: String,
        required: false,
      },
      required: {
        type: Boolean,
        required: false,
        default: false,
      },
      min: {
        type: String,
        required: false,
      },
      max: {
        type: String,
        required: false,
      },
      typeMonth: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        isToShowDatePicker: false,
      }
    },
    computed: {
      datePickerType () {
        return this.typeMonth ? 'month' : 'date'
      },
      formattedValueToDisplay () {
        return this.typeMonth
          ? this.$options.filters.formatMonth(this.value)
          : this.$options.filters.formatDate(this.value)
      },
      rules () {
        return this.required ? [required] : []
      },
    },
    methods: {
      onSelectDate (event) {
        this.$emit('input', event)
        this.toggleDatePicker()
      },
      toggleDatePicker () {
        this.isToShowDatePicker = !this.isToShowDatePicker
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          placeholder: 'Selecione a data pelo calendário.',
        },
        'en-US': {
          placeholder: 'Select the date from the calendar.',
        },
      },
    },
  }
</script>
